#include <Adafruit_NeoPixel.h>
#include <Adafruit_GFX.h>
#include <Adafruit_NeoMatrix.h>

#define MATRIX_PIN 0 // GPIO pin connected to the LED matrix data pin
#define MATRIX_WIDTH 10
#define MATRIX_HEIGHT 10

Adafruit_NeoMatrix matrix = Adafruit_NeoMatrix(MATRIX_WIDTH, MATRIX_HEIGHT, MATRIX_PIN,
  NEO_MATRIX_TOP + NEO_MATRIX_LEFT +
  NEO_MATRIX_ROWS,
  NEO_GRB + NEO_KHZ800);

int x = 0; // Initialize position

void setup() {
  Serial.begin(115200);
  Serial.println("Matrix scrolling text display setup...");

  matrix.begin();
  matrix.setTextWrap(false);
  matrix.setBrightness(50);
  matrix.setTextColor(matrix.Color(0, 0, 255)); // White color for text
  matrix.setTextSize(1); // Ensure text size is appropriate
  x = matrix.width(); // Start cursor position at the matrix width
}

void loop() {
  matrix.fillScreen(0); // Clear screen
  const char *text = "Why don't scientists trust atoms? Because they make up everything!";
  
  matrix.setCursor(x, 0);
  matrix.print(text);
  Serial.print("Cursor X position: "); Serial.println(x);
  Serial.print("Text to display: "); Serial.println(text);

  int textWidth = 6 * strlen(text); // Calculate the width of the text
  if (--x < -textWidth) {
    x = matrix.width();
    Serial.println("Resetting cursor position.");
  }

  matrix.show();
  delay(110); // Adjust the delay to control the scrolling speed
}

